#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define all(x) (x).begin(), (x).end()
using pii = pair<int, int>;

struct ss {
    int a, b, c;
    /*
    bool operator<(ss x) const {
        return a < x.a;
    }*/
};

signed main(){
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();

    int t, n, a, b, c, ans = 0;
    cin >> t;

    while(t--) {
        cin >> n;

        vector<ss> v(n);
        vector<int> sum(n + n, 0);
        map<int, vector<int>> mp;
        ans = 0;

        for(int i = 0; i < n; i++) {
            cin >> a >> b >> v[i].c;
            a--;
            b--;
            v[i].a = min(a, b);
            v[i].b = max(a, b);
            sum[a] += v[i].c;
            sum[b] += v[i].c;
            mp[a].pb(c);
        }

        /*for(int i: sum) {
            cout << i << " ";
        }
        cout << "\n";*/

        ans = *max_element(all(sum));

        for(int i = 0; i < n; i++) {
            for(int j = 0; j < n; j++) {
                if(i == j) {
                    continue;
                }

                for(int k = 0; k < n; k++) {
                    if(i == k || j == k) {
                        continue;
                    }

                    if((v[i].a == v[j].a && v[i].b == v[k].a && v[k].b == v[j].b) || (v[i].b == v[j].b && v[i].a == v[k].b && v[k].a == v[j].a)) {
                        ans = max(ans, v[i].c + v[j].c + v[k].c);
                    }
                }
            }
        }

        cout << ans << "\n";
    }

    return 0;
}
// :)
